#!ruby         
# === export_webgl_150420.rb ===
# 2011/Mar - 2014/Nov webgl_export.rb
#          - 2015/Apr change library canvas.js >> three.js
#                                              by Akitenh
# 
# SketchUp's Plug_in script: Export SketchUpModel to WebGL-script
# based on WebGL codes -- three.js(r7.10)
#Powered by Three.js(License: The MIT License (MIT)).
#2015/12/11 - Modified by TAK2HATA.v0.7.0
#2015/12/16 - Modified by TAK2HATA.Texture Mapping.v0.8.0
#2015/12/19 - Modified by TAK2HATA.Texture Mapping with base64 string.v0.8.5
#2015/12/23 - Modified by TAK2HATA.Instancing and uv bug fix.v0.9.0
#2015/12/25 - Modified by TAK2HATA.Add new UI.v0.9.5
#2015/12/26 - Modified by TAK2HATA.Add FlySpeed Control.v0.9.6
#2016/01/06 - Modified by TAK2HATA.AlphaTest Add.v0.9.7.
#2016/01/24 - Modified by TAK2HATA.Improve Scene Select.v0.9.8.
#2016/01/29 - Modified by TAK2HATA.Camera FOV support.Able to run on IE.Select showing axes.v0.9.9.
#Exporter for webGL.(Based on SU2WEBGL by AKITENKOSI).
#General disclaimer
#I MAKES NO GUARANTEE OF VALIDITY about this script.
#Please use this script at your own risk.
#免責事項
#このスクリプトによって如何なる損害が発生しても製作者は責任を負いません。各人の責任においてご使用ください
#このスクリプトは秋天越様作のSU2WEBGLをもとに改変し作られています。

require 'sketchup.rb'

module TAK2HATA
module WEBGL_EXPORT
class Webgl_export
	def show_status(m,prpt,fin=false)
	if @chklog == "是"
		@log.push "#{Time.now.to_i}:" + m
		if fin == true or ( Time.now.to_f - @wait ) > 1.0
			open(@logfile,'w'){|f|
				f.puts @log.reverse.join("<br>")
			}
			@wait = Time.now.to_f
		end
	else
		if( Time.now.to_f - @wait ) > 0.5
			Sketchup.set_status_text m
			p m
			@wait = Time.now.to_f
		end
	end
	end
  def init_props()
    @vi=@fi=@ei=0
    @vts=[]
	@fcs = []
	@uvs = []
	@eds = []
	@vtscnt = 0
	@fcscnt = 0
	@uvscnt = 0
	@edscnt = 0
	@vts[@vtscnt] = []
	@fcs[@fcscnt] = []
	@uvs[@uvscnt] = []
	@eds[@edscnt] = []
	@mti=[]   #material_index
  end
  def initialize( )
	#//インスタンスするのもいいけど、どのみちメッシュ量には限界があると思うので、geomを定義して、変形してからmeshを作りシーンに登録する。
	#//componentオブジェクトごとに分割しgeomにしてから、インスタンスごとにマテリアルインデックスに対応したマテリアルリストをつくる。
	#//compid = [nv,vlist[],nf,fcslist[],ned,edlist[],matilist[]]
	#//[compid,defmatslist[],mtxlist[]]
	#//matlist[]とtexlist[]は共通
	#//のような形で展開するdefmatlistには置き換え分のマテリアルのみを入れてmateriallist[0]を差し替えて使う
	#//sketchup側ではインスタンスをまず書き出して登録し、modelを解析するときに登録済みのインスタンスはmatlistとmtxlistに保存して管理する。
	@wait = Time.now.to_f

	@logfile = File.join(File.dirname(__FILE__),"webgl_export_log.html")
	@log = []
	@prec=5 #小数点以下有効桁数、単位cm

    
    @mtl=[["default", 0, "0xcccccc", 1.0, "" , 1.0 , 1.0 ]] #used_material_color
	@mthash = Hash.new
	@mthash[nil] = 0
    @txs=[]
	@tw = Sketchup.create_texture_writer
	@twhandle = {}
	mydir = File.dirname(__FILE__)
	threejsfile = File.join(mydir,"three.min.js")
	orbitfile = File.join(mydir,"OrbitControlsTH.min.js")
	axisfile = File.join(mydir,"LineAxisHelper.js")
	guifile = File.join(mydir,"DAT.GUI.min.js")

    model = Sketchup.active_model
	
	scenelength = model.bounds.diagonal
    ents1 = ente  = model.entities
    ##ent1  = model.selection
    return if ents1.count == 0

    gscl = 1000.0

    #svname, @enbltx = prompt()
	res1 = Sketchup.read_default( "T2H_EXPORT_WEBGL","导出类型", "多个文件" )
	res2 = Sketchup.read_default( "T2H_EXPORT_WEBGL","导出纹理", "导出为图像文件" )
	res3 = Sketchup.read_default( "T2H_EXPORT_WEBGL","显示坐标轴", "是" )
    title   = "导出模型到 WebGL"
    enums   = [ "单个文件|多个文件","无|导出为图像文件|导出为 JS 文件","是|否" ]
    prompts = [ "导出类型","导出纹理","显示坐标轴" ]#"No|To_Image_File|To_JS_file"@extext
    values  = [ res1 , res2 , res3 ]
    results = UI.inputbox( prompts, values, enums, title )
	if results
		export_onefile = results[0]
		@extext = results[1]
		use_axes = results[2]
		Sketchup.write_default( "T2H_EXPORT_WEBGL","导出类型", export_onefile )
		Sketchup.write_default( "T2H_EXPORT_WEBGL","导出纹理", @extext )
		Sketchup.write_default( "T2H_EXPORT_WEBGL","显示坐标轴", use_axes )
	else
		return
	end
	
    fn = UI.savepanel("导出模型为网页(html)文件", nil, "*.html")
	return unless fn
	fn = File.join(File.dirname(fn),File.basename(fn,".html") + ".html")
	svname = fn
    return if svname == ""
	starttime = Time.now.to_f
	
	dp=File.join(File.dirname(svname),"scene_thumb")
	Dir.mkdir(dp) if File.directory?(dp)==false
	#全シーンのサムネイルを書き出す
	pages = model.pages
	if pages.count != 0
		view = model.active_view
		original_page = pages.selected_page
		showtransitions = model.options["PageOptions"]["ShowTransition"]
		model.options["PageOptions"]["ShowTransition"] = false
		path = File.dirname(model.path)
		scenecnt = 0
		
		pages.each do |page|
			#if page.name==page.label
			pn = File.join(dp,"#{sprintf("%05d",scenecnt)}.jpg")
			Sketchup.set_status_text("Writing #{pn}")
			pages.selected_page = page
			view.write_image(pn,80,40,true)
			scenecnt += 1
			#end
		end
		pages.selected_page = original_page
		model.options["PageOptions"]["ShowTransition"] = showtransitions
	end
	#サムネイル書き出し終了
	
	@chklog = "否"
	if @chklog == "是"
		show_status "#{Time.now.strftime("%H%M%S")}:Start Export WebGL<br>\n",true,true
		UI.openURL File.join(File.dirname(__FILE__),"log_viewer.html")
	end

    view = model.active_view
    cam = view.camera
    ceye = cam.eye
	cvec = ceye.vector_to(cam.target)
	if scenelength != 0.0 and cvec.length != 0.0
	end
    ctgt = ceye + cvec
    defmat="default"
	po=Geom::Point3d.new
	mns = 1.inch.to_cm
	
    #t0 = Geom::Transformation.translation(po.vector_to(Geom::Point3d.new( 0,0,0 ))) * Geom::Transformation.scaling(mns)
	t0 = Geom::Transformation.scaling(mns)
	scenemin = model.bounds.corner(2).transform(t0)
	scenemax = model.bounds.corner(5).transform(t0)
	scenecenter = model.bounds.center.transform(t0)
	
	sinfo = Sketchup.active_model.shadow_info
	sundir = sinfo["SunDirection"]
	
	pcam=ceye.transform(t0)
	ptgt=ctgt.transform(t0)
	if cam.perspective?
		pfov = cam.fov
	else
		pfov = 45
	end
	
	htmlheader = get_html_header()
	geomfilename = File.basename(svname,".html") + "geom.js"
	savedir = File.dirname(svname)
	geomfile = File.join(savedir,geomfilename)
	if export_onefile == "单个文件"
		geomfile = svname
		f=open(geomfile, "w")
		f.print (htmlheader)
		f.print %Q(<script itype="text/javascript" >)
		f.print (open(threejsfile, &:read))
		f.print "</script>"
		f.print %Q(<script itype="text/javascript" >)
		f.print (open(orbitfile, &:read))
		f.print "</script>"
		if use_axes == "是"
			f.print %Q(<script itype="text/javascript" >)
			f.print (open(axisfile, &:read))
			f.print "</script>"
		end
		f.print %Q(<script itype="text/javascript" >)
		f.print (open(guifile, &:read))
		f.print "</script>"
		f.print %Q(<script itype="text/javascript" >)
		f.print ("function main_wgl() { prec=#{@prec};")
		if @extext != "否"
			f.print( "use_texture=true;" )
		else
			f.print( "use_texture=false;" )
		end
		f.print ("geomlist=[\n")
		f.close
	else
		htmlheader += %Q(
		  <script src="three.min.js"></script>
		  <script src="OrbitControlsTH.min.js"></script>
		  <script src='DAT.GUI.min.js'></script>
		  <script src="#{geomfilename}"></script>
		)
		filecopy(threejsfile, File.join(savedir,"three.min.js"))
		filecopy(orbitfile , File.join(savedir,"OrbitControlsTH.min.js"))
		filecopy(guifile , File.join(savedir,"DAT.GUI.min.js"))
		if use_axes == "是"
			htmlheader += %Q{<script src="LineAxisHelper.js"></script>}
			filecopy(axisfile , File.join(savedir,"LineAxisHelper.js"))
		end
		f=open(geomfile, "w")
		f.print ("function main_wgl() { prec=#{@prec};")
		if @extext != "否"
			f.print( "use_texture=true;" )
		else
			f.print( "use_texture=false;" )
		end
		f.print ("geomlist=[\n")
		f.close
	end
	
	#最初にent1から掘り下げる
	
	init_props()
	@geomlist = Hash.new#[compid,defmatslist[],mtxlist[]]
	@geomlist[ Sketchup.active_model ] = []
	@geomlist[ Sketchup.active_model ].push [ nil , Geom::Transformation.new ]
	#インスタンスの情報を収集
	show_status "search instances", SB_PROMPT
	search_instances(ents1,Geom::Transformation.new,nil)
	show_status "search instances end", SB_PROMPT
	
	#show_status "search face", SB_PROMPT
    #search_face(ents1, t0, nil)
	#show_status "search face end", SB_PROMPT
	f=open(geomfile, "a")
	#writing_geoms(f)
	#f.print (",\n")
	#f.close

	@geomlist.each{|key,val|
		show_status "search faces of instance", SB_PROMPT
		init_props()
		@chkins = true 
		@chkins = false if key == Sketchup.active_model
		search_face(key.entities , t0 , nil)
		show_status "search faces of instance end", SB_PROMPT
		#if @vi > 0
			#f=open(geomfile, "a")
			writing_geoms(f)
			f.print (",\n")
			#f.close
		#end
	}
	#f=open(geomfile, "a")
	f.print ("]\n")
	f.print ("ngeom=#{@geomlist.size};\n")
	f.print ("inslist=[")
	geomi = 0
	xrot = Geom::Transformation.rotation([0,0,0],Geom::Vector3d.new(1,0,0),90.degrees)
	@geomlist.each{|key,val|
		f.print ("{nins:#{val.size},props:[")
		val.each{|ins_mat,ins_tr|
			f.print ("{dfmat:#{@mthash[ins_mat]},")
			ins_tr2 = t0 * ins_tr * t0.inverse
			f.print ("matrix:#{(ins_tr2).to_a}},")
		}
		f.print ("]},")
		geomi += 1
	}
	f.print ("]\n")
	if @extext != "否"
		export_textures(svname)
	end
    mlst=""; i=0
    @mtl.each do |m|
	  if @extext != "否" and @twhandle[m[0]]
		h = @twhandle[m[0]]
		txfile = @tw.filename(h)
		mlst += "mat[#{m[1]}]=[ #{m[2]}, #{m[3]}, \'#{File.extname(txfile).downcase.sub(/\./,"")}\' , '#{m[4]}' , #{m[5]} , #{m[6]} ];\n"
	  else
		mlst += "mat[#{m[1]}]=[ #{m[2]}, #{m[3]}, \'\' , '#{m[4]}', #{m[5]} , #{m[6]} ];\n"
	  end
      i+=1
    end
	show_status "arraying material end", SB_PROMPT
	if @extext != "否"
		tlst=[]; i=0
		@txs.each do |m|
		  h = @twhandle[m[0]]
		  txfile = @tw.filename(h)
		  if @extext == "导出为图像文件"
			  tlst.push "tex[#{m[2]}]=\'gl_image\/#{txfile}\';\n"
		  else
			  txfile = File.join(savedir,"gl_image",txfile)
			  tbase64 = "data:image/#{File.extname(txfile).downcase.sub(/\./,"")};base64,#{[File.binread(txfile)].pack("m0")}"
			  tlst.push "tex[#{m[2]}]=\'#{tbase64}\';\n"
		  end
		  i+=1
		end
		@tw = nil
		show_status "arraying texture end", SB_PROMPT
	end
	f.print ("mat =[];#{mlst}")
	if @extext != "否"
		f.print ("tex =[];#{tlst.join}")
	end
	f.print ("}")
	if export_onefile == "单个文件"
		f.print "</script>"
	end
	f.close

	show_status "wrighting geom file end", SB_PROMPT
	prec="%.3f"
	rowmax = 4 #列の最大数
	rowcnt = 0
	scenelist = []
	scene_name = "环绕观察视图"
	pgfov = 45
	scene_code =  %Q{scenetable = '<table border="5" bordercolor="#ffffff" style="table-layout:fixed;" width="100%" height="100%"><tr>'\n}
	scene_code += %Q{+ '<td class="lt-cell" onclick="scenechange(} + "[#{sprintf( "#{prec},#{prec},#{prec}",scenemax.x*1.0,scenemax.z*1.0,-scenemax.y*1.0)}],"
	scene_code += %Q{[#{sprintf( "#{prec},#{prec},#{prec}",scenecenter.x*1.0,scenecenter.z*1.0,-scenecenter.y*1.0)}],#{pgfov})\">#{scene_name}</td>'\n}
	rowcnt += 1
	#scene_code += "case \"OrbitView\":"
	#scene_code += "cpos=[#{sprintf( "#{prec},#{prec},#{prec}",scenemax.x*1.0,scenemax.z*1.0,-scenemax.y*1.0)}];"
	#scene_code += "ctgt=[#{sprintf( "#{prec},#{prec},#{prec}",scenecenter.x*1.0,scenecenter.z*1.0,-scenecenter.y*1.0)}];break;\n"
	#scenelist.push "\"OrbitView\""
	scenecnt = 0

	if pages.count != 0
		model.pages.each{|pg|
			pgceye = pg.camera.eye
			if pg.camera.perspective?
				pgfov = pg.camera.fov
			else
				pgfov = 45
			end

			cvec = pgceye.vector_to(pg.camera.target)
			if scenelength != 0.0 and cvec.length != 0.0
				#cvec.length = scenelength * 0.5
			end
			pgctgt = pgceye + cvec
			pgcam=pgceye.transform(t0)
			pgtgt=pgctgt.transform(t0)
			if rowcnt == 0
				scene_code += "+ '<tr>'"
			end
			pn = File.join("scene_thumb","#{sprintf("%05d",scenecnt)}.jpg")
			scene_code += %Q{+ '<td class="lt-cell" onclick="scenechange([#{sprintf( "#{prec},#{prec},#{prec}",pgcam.x*1.0,pgcam.z*1.0,-pgcam.y*1.0)}],}
			scene_code += %Q{[#{sprintf( "#{prec},#{prec},#{prec}",pgtgt.x*1.0,pgtgt.z*1.0,-pgtgt.y*1.0)}],#{pgfov})\">}
			if @extext == "导出为图像文件"
			  scene_code += %Q{<img border="0" src="#{pn}" alt="#{pg.name}">#{pg.name}</td>'\n}
			else
			  pnbase64 = "data:image/jpg;base64,#{[File.binread(File.join(dp,"#{sprintf("%05d",scenecnt)}.jpg"))].pack("m0")}"
			  scene_code += %Q{<img border="0" src="#{pnbase64}" alt="#{pg.name}">#{pg.name}</td>'\n}
			end
			
			scenecnt += 1
			rowcnt += 1
			if rowcnt > rowmax
				rowcnt = 0
				scene_code += "+ '</tr>'"
			end
			##scene_code += "case \"#{pg.name}\":"
			##scene_code += "cpos=[#{sprintf( "#{prec},#{prec},#{prec}",pgcam.x*1.0,pgcam.z*1.0,-pgcam.y*1.0)}];"
			##scene_code += "ctgt=[#{sprintf( "#{prec},#{prec},#{prec}",pgtgt.x*1.0,pgtgt.z*1.0,-pgtgt.y*1.0)}];break;\n"
			##scenelist.push "\"#{pg.name}\""
		}
		if rowcnt > 0
			scene_code += "+ '</tr></table>';"
		else
			scene_code += "+ '</table>';"
		end
	else
		scene_code += "+ '</tr></table>';"
	end
	htmltemp = get_html_templete()
	htmltemp.sub!(/GEOMJS_FILENAME/,geomfilename)
	if use_axes == "是"
		axescode=%Q{axis = new THREE.AxisHelper(5000);axis.position.set(0, 0, 0);axis.applyMatrix(mrot);scene.add(axis);}
		htmltemp.sub!(/USE_AXES/,axescode)
	else
		htmltemp.sub!(/USE_AXES/,"")
	end
	htmltemp.sub!(/CAMEYE/,"#{sprintf( "#{prec},#{prec},#{prec}",pcam.x*1.0,pcam.z*1.0,-pcam.y*1.0)}")
	htmltemp.sub!(/CAMTGT/,"#{sprintf( "#{prec},#{prec},#{prec}",ptgt.x*1.0,ptgt.z*1.0,-ptgt.y*1.0)}")
	htmltemp.sub!(/CAMFOV/,"#{pfov}")
	#htmltemp.sub!(/SCENE_LIST/,scenelist.join(","))
	htmltemp.sub!(/SCENE_SELECT/,scene_code)
	htmltemp.sub!(/SCENE_MAX_LENGTH/,"#{(scenelength * mns * 10).to_i}")
	htmltemp.sub!(/SCENE_CENTER/,"#{scenecenter.x*1.0},#{scenecenter.z*1.0},#{-scenecenter.y*1.0}")
	htmltemp.sub!(/SCENE_SUNVEC/,"#{sundir.x*1.0},#{sundir.z*1.0},#{-sundir.y*1.0}")
	htmltemp.sub!(/SCENESIZE/,"#{sprintf( "#{prec},#{prec},#{prec}",scenemax.x*1.0-scenemin.x*1.0,scenemax.z*1.0-scenemin.z*1.0,-scenemax.y*1.0+scenemin.y*1.0)}")
	htmltemp.sub!(/SCENEMIN/,"#{sprintf( "#{prec},#{prec},#{prec}",scenemin.x*1.0,scenemin.z*1.0,-scenemin.y*1.0)}")
	#orbit controlを使うとlookatは無効
	show_status "reading template end", SB_PROMPT
    
	if export_onefile == "单个文件"
		f=open(svname, "a")
		f.print (htmltemp)
		f.close
	else
		f=open(svname, "w+")
		f.print (htmlheader)
		f.print (htmltemp)
		f.close
	end
    show_status "wrighting htmlend", SB_PROMPT

	show_status "finished!:time#{Time.now.to_f - starttime}sec", SB_PROMPT
	res = UI.messagebox( "导出完成！共耗时： #{sprintf("%.5f",Time.now.to_f - starttime)}秒。\n要使用默认浏览器打开这个网页吗？" ,MB_YESNO)
	if res == 6#YES
		UI.openURL(svname)
	end
  end
  def filecopy(ofile,tfile)
	if ofile and tfile and ofile != "" and tfile != "" and File.exist?(ofile) and ofile != tfile
		f=open(tfile, "w")
		f.print (open(ofile, &:read))
		f.close
	end
  end
  def writing_geoms(f)
	delim = ","
      f.print ("{nv:#{@vi},\n")
	  f.print ("v:[")
	  i = 0
	  @vts.each{|vtl|
		f.print (vtl.join(delim))
		if i < @vtscnt
			f.print (delim)
		end
		i += 1
	  }
	  f.print "],\n"
	  show_status "wrighting vertices end", SB_PROMPT
#      f.print (cns[1] + "\n")
#      f.print (@vts.inspect)
      f.print ("nf:#{@fi},\n")
	  f.print ("f:[")
	  i = 0
	  @fcs.each{|fcs|
		f.print (fcs.join(delim))
		if i < @fcscnt
			f.print (delim)
		end
		i += 1
	  }
	  f.print "],\n"
	  show_status "wrighting faces end", SB_PROMPT

	if @extext != "否"
	  f.print ("uv:[")
	  i = 0
	  @uvs.each{|uvs|
		f.print (uvs.join(delim))
		if i < @uvscnt
			f.print (delim)
		end
		i += 1
	  }
	  f.print "],\n"
	end

	  show_status "wrighting uvs end", SB_PROMPT
	  f.print ("ne:#{@ei},\n")
	  f.print ("ed:[")
	  i = 0
	  @eds.each{|eds|
		f.print (eds.join(delim))
		if i < @edscnt
			f.print (delim)
		end
		i += 1
	  }
	  f.print "],\n"
	  show_status "wrighting eds end", SB_PROMPT
	  f.print ("mti:[#{ @mti.join(",")}]")
	  f.print ("\n}//geom end\n")
	show_status "wrighting mat index end", SB_PROMPT
#      f.print (cns[5] + "\n")
#      f.print (@mti.inspect)

  end
#----------------------------
  def search_face(et1, t0, mt0)
  #グループだけ掘り下げてfaceを取得してゆく
  fcs = et1.find_all{|e| e.is_a?(Sketchup::Face)}
  inss = et1.find_all{|e| e.is_a?(Sketchup::ComponentInstance)}
  grps = et1.find_all{|e| e.is_a?(Sketchup::Group)}
  #entities内でエッジ登録を蓄積して必要分に限定する
  @edslist = Hash.new
  @vtsindices = Hash.new

	fcs.each{|e| 
		if e.visible? and e.layer.visible?
			check_face(e,t0,mt0)
		end
	}
	@vi += @vtsindices.size
	@edslist.clear
	@vtsindices.clear

	grps.each{|e|
		if e.visible? and e.layer.visible?
			mt1 = e.material || mt0
			t1  = t0 * e.transformation
			sel = e.definition.entities
			search_face(sel, t1, mt1)
		end
	}
  end
  def search_instances(ents,t0,mt0)
  #インスタンスの位置・材質情報のみ蓄積
	inss = ents.find_all{|e| e.is_a?(Sketchup::ComponentInstance) or e.is_a?(Sketchup::Group)}
	inss.each{|e|
		if e.visible? and e.layer.visible?
			mt1 = e.material || mt0
			if not @mthash[mt1]
				matname = "default"
				matname = mt1.name if mt1 != nil
				has_texture = checktexture(mt1)
				self.store_mat(mt1, matname, has_texture,e)
			end
			t1  = t0 * e.transformation
			sel = e.definition.entities
			if not e.is_a?(Sketchup::Group)
				@geomlist[e.definition] = [] if not @geomlist[e.definition]
				@geomlist[e.definition].push [ mt1 , t1 ]
			end
			search_instances(sel, t1, mt1)
		end
	}
  end
def fcompress(v)
	return ( v * 10 ** @prec ).to_i.to_s(36)
end
def checktexture( mat)
	has_texture = nil
	if(mat != nil and mat.materialType != 0 and [".jpg",".jpeg",".png",".gif",".bmp",".tif"].include?(File.extname(mat.texture.filename).downcase) )
		has_texture = mat.texture
	end
	return has_texture
end
def check_face(e, t, mat)
	has_texture = nil
	prec="%.3f"
	#mat = e.material if e.material != nil
	mat = e.material || mat
	if mat==nil
		matname = "default"
	else
		matname = mat.name
	end
	has_texture = checktexture(mat)

	mtn = self.store_mat(mat, matname, has_texture,e)
	uscale = 1.0
	vscale = 1.0
	
	#if e.material and e.material.materialType != 0#あくまで面自体のマテリアルでUVスケールを決める
	#	uscale = e.material.texture.width
	#	vscale = e.material.texture.height
	#end
	#逆に面エンティティ自体にマテリアルがない場合のテクスチャスケールの適応として使う
	#インスタンスで最終的にデフォルトマテリアルのマテリアル上書きのある場合のみはuvスケールをwebglで上書きすることにする。
	#つまり「グループの場合」で「面マテリアルが無」で「テクスチャ付きの上書きマテリアルがある」条件ではuv換算を今行う。
	#if not e.material and mat and mat.materialType != 0 and @chkins == false
	if not e.material and has_texture != nil and @chkins == false
		uscale = 1.0 / mat.texture.width
		vscale = 1.0 / mat.texture.height
	end
	norm = e.normal
	mesh = e.mesh 5
	cp=mesh.count_polygons
	(1..cp).each do |j|
		if @vts[@vtscnt].length > 6000
			@vtscnt += 1
			@vts[@vtscnt] = []
		end
		if @fcs[@fcscnt].length > 6000
			@fcscnt += 1
			@fcs[@fcscnt] = []
		end
		if @uvs[@uvscnt].length > 6000
			@uvscnt += 1
			@uvs[@uvscnt] = []
		end

		pts = mesh.polygon_points_at(j)
		uvi="["
		fc ="\""
		pts.each do |pt|
			k=mesh.point_index(pt)
			pn = pt.transform t
			pnx = "\"#{fcompress(pn.x)},#{fcompress(pn.y)},#{fcompress(pn.z)}\""
			#さらに数値を圧縮する方法として有効小数点以下桁数を決める。今のところ３位としたい。
			#10**3を掛けてから.to_s(36)で３６進数にして、html側で10進数にもどし10**3で割る
			
			vi = @vtsindices[pnx]
			if not vi
				vi = @vtsindices[pnx] = @vtsindices.size
				@vts[@vtscnt].push pnx
			end
			#-- SketchupのUV値をそのまま出力してる．．が
			#   これだとwebgl(three.js)のUVマッピングが変__150425現在
			pu = mesh.uv_at(k,1)
			uvi += "\"#{fcompress(pu.x * uscale)},#{fcompress(pu.y * vscale)}\","
			#else
			#	uvi += ","
			#end
			fc+= "#{(vi + @vi).to_s(36)},"
		end
		uvi.chop!; uvi+="]"
		fc.chop!; fc+="\""
		@fcs[@fcscnt].push fc
		@uvs[@uvscnt].push uvi
		@mti << mtn
		@fi += 1
		#show_status "#{@fi}", SB_PROMPT
	end
	if @eds[@edscnt].length > 6000
		@edscnt += 1
		@eds[@edscnt] = []
	end
	e.edges.each{|ed|
	if ed.visible? and ed.layer.visible? and not ed.soft? and not ed.smooth? and not @edslist[ed]
		@edslist[ed] = true
		pt1 = ed.start.position.transform t
		pt2 = ed.end.position.transform t
		pt1i = @vtsindices["\"#{fcompress(pt1.x)},#{fcompress(pt1.y)},#{fcompress(pt1.z)}\""]
		pt2i = @vtsindices["\"#{fcompress(pt2.x)},#{fcompress(pt2.y)},#{fcompress(pt2.z)}\""]
		if pt1i and pt2i
			@eds[@edscnt].push "\"#{(pt1i + @vi).to_s(36)},#{(pt2i + @vi).to_s(36)}\""
			@ei += 1
		end
	end
	}

end

#----------------------------
	def export_textures(svname)
		#dp=svname[0..svname.rindex(/\\/)]+"gl_image"
		dp=File.join(File.dirname(svname),"gl_image")
		Dir.mkdir(dp) if File.directory?(dp)==false
		#@texnames_bymat = Hash.new("")#ここのマテリアルに対応したテクスチャファイル名を収納
		@tw.write_all(dp, true)

		show_status "exporting texture_end", SB_PROMPT
	end

  def store_mat(mat, mnam, mtex , ent)
  	urepeat = 1.0
	vrepeat = 1.0
	if mtex != nil
		urepeat = 1.0 / mat.texture.width
		vrepeat = 1.0 / mat.texture.height
	end
	m_ex = @mthash[mat]
	if m_ex
		return m_ex
	end
	m_ex=@mtl.size
	@mthash[mat] = m_ex
	if mtex != nil and ( ent.is_a?(Sketchup::Face) or ent.is_a?(Sketchup::ComponentInstance) or ent.is_a?(Sketchup::Group) or ent.is_a?(Sketchup::Image) )
		h = @tw.load(ent,true)
		@twhandle[mat] = h
		#namtex = @tw.filename(h).downcase
		col=mat.texture.average_color
		mcol= "0x"+(sprintf("%2x",col.red)).sub(/ /,"0")+(sprintf("%2x",col.green)).sub(/ /,"0")+(sprintf("%2x",col.blue)).sub(/ /,"0")
		difs=[m_ex, mcol, mat.alpha , mnam , urepeat , vrepeat]
		@txs << [mat ,mnam, m_ex ] 
	else
		col =mat.color
		mcol= "0x"+(sprintf("%2x",col.red)).sub(/ /,"0")+(sprintf("%2x",col.green)).sub(/ /,"0")+(sprintf("%2x",col.blue)).sub(/ /,"0")
		difs=[m_ex, mcol, mat.alpha , mnam , urepeat , vrepeat]
	end
	#difs[3] = "" if (@enbltx==0)
	@mtl << [mat, difs].flatten
    return m_ex
  end
	def is_png_use_alpha(filename)
		#filename = "C:\\freeware\\Mitsuba 0.5.0\\su_render\\tx_default\\chair.png"
		if File.extname(filename).upcase != ".PNG"
			return false
		end
		filepath = File.expand_path(File.join(@texture_exportpath,filename))
		if not File.exists?( filepath )
			return false
		end
		image = open(filepath, "rb")
		signature   = image.read(8)
		data_length = image.read(4).unpack(">N")[0]
		chunk_name  = image.read(4)
		#chunk       = image.read(data_length)
		width       = image.read(4).unpack(">N")[0]
		height      = image.read(4).unpack(">N")[0]
		bit_depth   = image.read(1).unpack("h")[0].to_i
		color_type  = image.read(1).unpack("h")[0].to_i
		#compression = image.read(1).unpack("h")[0].to_i
		#filter      = image.read(1).unpack("h")[0].to_i
		#interlace   = image.read(1).unpack("h")[0].to_i
		image.close
		if color_type == 4 or color_type == 6
			return true
		else
			return false
		end
	end
def get_html_header()
#code_header = open(File.join(File.dirname(__FILE__),"htmlheader.html"), &:read)

# 获取当前文件名（去掉路径和扩展名）
model_name = File.basename(Sketchup.active_model.path, ".*")

code_header =%Q(
<!DOCTYPE html>
<html>
<head>
<meta http-equiv="Content-Type" Content="text/html;charset=UTF-8">
<TITLE>#{model_name}</TITLE>
<!--
<meta name="viewport" content="target-densitydpi=device-dpi, width=device-width, user-scalable=no" />
-->
<style>
  body {
	margin: 0px;
	overflow: hidden;
  }
  #container {
	position: absolute;
	top: 0;
	left: 0;
	right: 0;
	bottom: 0;
  }
	#modal{display:none;}
	.lt-cell {
		background: #A9D0F5;
		font-size: x-large;
		font-weight: bold;
	}
	.lt-cell:hover{
		background: #F7BE81;
		font-size: x-large;
		font-weight: bold;
	}
	.modalBody{position: fixed; z-index:1000; background: #FFFFFF; width:80%; left:10%; top:10%; height: 80%}
	.modalBK{position: fixed; z-index:999; height:100%; width:100%;background:#000; opacity: 0.9;filter: alpha(opacity=60);-moz-opacity:0.60;}
</style>
</head>
<body style="overflow: hidden;height: 100%;">
<div id="modal">
	<div class="modalBody"><p id="sceneselect" ></p></div>
	<div class="modalBK" onclick='document.getElementById("modal").style.display="none";'></div>
</div>
  <div id="container"></div>
)
end
def get_html_templete()
#code = open(File.join(File.dirname(__FILE__),"htmltemplete.html"), &:read)
code=%Q(
<script type="x-shader/x-vertex" id="vertexShader">
	varying vec3 vWorldPosition;
	void main() {
		vec4 worldPosition = modelMatrix * vec4( position, 1.0 );
		vWorldPosition = worldPosition.xyz;
		gl_Position = projectionMatrix * modelViewMatrix * vec4( position, 1.0 );
	}
</script>
<script type="x-shader/x-fragment" id="fragmentShader">
	uniform vec3 topColor;
	uniform vec3 bottomColor;
	uniform float offset;
	uniform float exponent;
	varying vec3 vWorldPosition;
	void main() {
		float h = normalize( vWorldPosition + offset ).y;
		gl_FragColor = vec4( mix( bottomColor, topColor, max( pow( max( h , 0.0), exponent ), 0.0 ) ), 1.0 );
	}
</script>
<script id="main_wgl" type="text/javascript" >
	var materials = [];
	var clipMAX = 100.0;
	var clipMIN = 0.0;
	var camera,headlight;
	main_wgl();
	init();
	render();
	function scenechange(cpos,ctgt,fov){
		camera.fov = fov;
		controls.object.position.set(cpos[0],cpos[1],cpos[2]);
		controls.target = new THREE.Vector3(ctgt[0],ctgt[1],ctgt[2] ); 
		document.getElementById("modal").style.display="none";
		camera.updateProjectionMatrix();
	}
	function init() {
    if (window.WebGLRenderingContext) {
        renderer = new THREE.WebGLRenderer({ antialias: true });
    } else {
        renderer = new THREE.CanvasRenderer();
    }
	var chk_tex_ok = false;
	aspr = window.innerWidth/ window.innerHeight;
    renderer.setPixelRatio( window.devicePixelRatio );
	renderer.setSize( window.innerWidth, window.innerHeight );
    document.getElementById('container').appendChild(renderer.domElement);
    renderer.setClearColor(0x606069, 1.0);
	renderer.autoClear = false;
	renderer.shadowMap.enabled = true;
	renderer.shadowMap.type = THREE.PCFShadowMap;
    scene = new THREE.Scene();
	var scene_length = SCENE_MAX_LENGTH;
    camera = new THREE.PerspectiveCamera(CAMFOV, aspr, 10, scene_length);
    scene.add(camera);
    light1 = new THREE.AmbientLight(0xbbbbbb);
    scene.add( light1 );
    light2 = new THREE.DirectionalLight(0xcccccc, 1.0);
	tpos =new THREE.Vector3( SCENE_CENTER );
	sunvec = new THREE.Vector3( SCENE_SUNVEC );
	sunvec.setLength( scene_length / 2 );
    light2.position.set(sunvec.x + tpos.x , sunvec.y + tpos.y, sunvec.z + tpos.z);
	light2.target.position.set(tpos);
	light2.castShadow = true;
	light2.shadowCameraNear = scene_length / 2 * 0.85;
	light2.shadowCameraFar = scene_length / 2 * 1.15;
	light2.shadowCameraRight = scene_length/15;
	light2.shadowCameraLeft = -scene_length/15;
	light2.shadowCameraTop	= scene_length/15;
	light2.shadowCameraBottom = -scene_length/15;
	light2.shadowCameraFov = 1.0;
	light2.shadowCameraVisible = true;
	light2.shadowBias = 0.0001;
	light2.shadowMapWidth = 2048;
	light2.shadowMapHeight = 2048;
    scene.add( light2 );
    light3 = new THREE.DirectionalLight(0x333333, 1.0);
    light3.position.set(-sunvec.x,-sunvec.y,-sunvec.z);
    scene.add( light3 );
    headlight = new THREE.DirectionalLight(0x333333, 1.0);
    headlight.position.set(0, 0, 0);
    scene.add( headlight );
	hemiLight = new THREE.HemisphereLight( 0xffffff, 0xffffff, 0.1 );
	hemiLight.color.setHSL( 0.6, 1, 0.6 );
	hemiLight.groundColor.setHSL( 0.095, 1, 0.75 );
	hemiLight.position.set( 0, 0, 0 );
	scene.add( hemiLight );
	// SKYDOME
	var vertexShader = document.getElementById( 'vertexShader' ).textContent;
	var fragmentShader = document.getElementById( 'fragmentShader' ).textContent;
	var uniforms = {
		topColor: 	 { type: "c", value: new THREE.Color( 0x0077ff ) },
		bottomColor: { type: "c", value: new THREE.Color( 0xffffff ) },
		offset:		 { type: "f", value: 33 },
		exponent:	 { type: "f", value: 0.6 }
	};
	uniforms.topColor.value.copy( hemiLight.color );
	//scene.fog.color.copy( uniforms.bottomColor.value );
	var skyGeo = new THREE.SphereGeometry( scene_length/2, 32, 15 );
	skyGeo.translate(tpos.x,tpos.y,tpos.z);
	var skyMat = new THREE.ShaderMaterial( { vertexShader: vertexShader, fragmentShader: fragmentShader, uniforms: uniforms, side: THREE.BackSide } );
	var sky = new THREE.Mesh( skyGeo, skyMat );
	scene.add( sky );
    // init controls : use OrbitControls.js
	controls = new THREE.OrbitControlsTH(camera, renderer.domElement);
	controls.userZoom = true;
	controls.userZoomSpeed = 1.0;
	controls.userRotate = true;
	controls.userRotateSpeed = 1.0;
	controls.userPan = true;
	controls.userPanSpeed = 1.0;
	controls.autoRotate = false;
	controls.autoRotateSpeed = 1.0;
	controls.minPolarAngle = 0; 
	controls.maxPolarAngle = Math.PI; 
	controls.minDistance = 0;
	controls.maxDistance = Infinity;
	controls.object.position.set( CAMEYE );
	controls.target = new THREE.Vector3( CAMTGT ); 
	controls.lookaround = false;
	controls.flyspeed = 50;
	
	var mrot = new THREE.Matrix4();
	mrot.makeRotationX(-Math.PI/2);
	USE_AXES
	
    // init materials
	codeclips = "vec3 clipDIST = vec3( SCENESIZE ) + vec3(40,40,40);vec3 clipBASE = vec3( SCENEMIN ) - vec3(20,20,20);"
    for(var i=0; i < mat.length; i++){
     materials[i] = new THREE.ShaderMaterial( {
		uniforms: THREE.UniformsUtils.merge([
			THREE.UniformsLib[ "common" ],
			//THREE.UniformsLib[ "fog" ],
			THREE.UniformsLib[ "lights" ],
			THREE.UniformsLib[ "shadowmap" ],
			{
			usemap : { type : "i" , value : 0 },
			clipmaxX: { type: 'f', value: clipMAX },
			clipminX: { type: 'f', value: clipMIN },
			clipmaxY: { type: 'f', value: clipMAX },
			clipminY: { type: 'f', value: clipMIN },
			clipmaxZ: { type: 'f', value: clipMAX },
			clipminZ: { type: 'f', value: clipMIN },
			opacity: { type: 'f', value: mat[i][1] },
			alphatest: { type: 'f', value: 0.0 },
			use_clipping: { type: 'i', value: 1 },
			diffuse: { type: 'c', value: new THREE.Color(mat[i][0]) },
			emissive : { type: "c", value: new THREE.Color( 0x000000 ) }
		}]),
		vertexShader: [	
			THREE.ShaderChunk[ "common" ],
			"varying vec3 mdpos;","varying vec3 vLightFront;",
			"#ifdef DOUBLE_SIDED","	varying vec3 vLightBack;","#endif",
			"varying vec2 vUv;",
			"uniform vec4 offsetRepeat;",
			THREE.ShaderChunk[ "lights_lambert_pars_vertex" ],
			THREE.ShaderChunk[ "color_pars_vertex" ],
			THREE.ShaderChunk[ "shadowmap_pars_vertex" ],
			"void main() {",
				"vUv = uv * offsetRepeat.zw + offsetRepeat.xy;",
				THREE.ShaderChunk[ "color_vertex" ],
				THREE.ShaderChunk[ "beginnormal_vertex" ],
				THREE.ShaderChunk[ "defaultnormal_vertex" ],
				THREE.ShaderChunk[ "begin_vertex" ],
				THREE.ShaderChunk[ "project_vertex" ],
				THREE.ShaderChunk[ "worldpos_vertex" ],
				THREE.ShaderChunk[ "envmap_vertex" ],
				THREE.ShaderChunk[ "lights_lambert_vertex" ],
				THREE.ShaderChunk[ "shadowmap_vertex" ],
			"mdpos = vec3(position);}"
		].join( "\\n" ),
		fragmentShader: [
			"uniform float clipmaxX;", "uniform float clipminX;", "uniform float clipmaxY;", "uniform float clipminY;", "uniform float clipmaxZ;", "uniform float clipminZ;","uniform int use_clipping;",
			"varying vec3 mdpos;",
			"uniform vec3 diffuse;","uniform vec3 emissive;","uniform float opacity;","uniform vec3 ambientLightColor;","varying vec3 vLightFront;","#ifdef DOUBLE_SIDED","	varying vec3 vLightBack;","#endif",
			"varying vec2 vUv;",
			"uniform sampler2D map;",
			"uniform int usemap;",
			"uniform float alphatest;",
			THREE.ShaderChunk[ "common" ],
			THREE.ShaderChunk[ "color_pars_fragment" ],
			THREE.ShaderChunk[ "alphamap_pars_fragment" ],
			THREE.ShaderChunk[ "shadowmap_pars_fragment" ],
			codeclips,
			"void main() {",
			"	vec3 outgoingLight = vec3( 0.0 );",
			"	vec4 diffuseColor = vec4( diffuse, opacity );",
			"	vec3 totalAmbientLight = ambientLightColor;",
			"	vec3 shadowMask = vec3( 1.0 );",
			THREE.ShaderChunk[ "logdepthbuf_fragment" ],
			"if( usemap == 1 ){",
			"vec4 texelColor = texture2D( map, vUv );",
			"texelColor.xyz = inputToLinear( texelColor.xyz );",
			"diffuseColor *= texelColor;}",
			THREE.ShaderChunk[ "color_fragment" ],
			THREE.ShaderChunk[ "alphamap_fragment" ],
			"if( alphatest > 0.0 && diffuseColor.a < alphatest ){ discard;}",
			THREE.ShaderChunk[ "shadowmap_fragment" ],
			"	#ifdef DOUBLE_SIDED",
			"		if ( gl_FrontFacing )",
			"			outgoingLight += diffuseColor.rgb * ( vLightFront * shadowMask + totalAmbientLight ) + emissive;",
			"		else",
			"			outgoingLight += diffuseColor.rgb * ( vLightBack * shadowMask + totalAmbientLight ) + emissive;",
			"	#else",
			"		outgoingLight += diffuseColor.rgb * ( vLightFront * shadowMask + totalAmbientLight ) + emissive;",
			"	#endif",
			THREE.ShaderChunk[ "linear_to_gamma_fragment" ],
			"if( use_clipping == 1 ){",
			"	vec3 clipmax = clipDIST * vec3( clipmaxX , clipmaxY , clipmaxZ ) * 0.01 + clipBASE;",
			"	vec3 clipmin = clipDIST * vec3( clipminX , clipminY , clipminZ ) * 0.01 + clipBASE;",
			"	vec3 linemax = clipDIST * vec3( clipmaxX , clipmaxY , clipmaxZ ) * 0.01 + clipBASE - vec3( 10,10,10 );",
			"	vec3 linemin = clipDIST * vec3( clipminX , clipminY , clipminZ ) * 0.01 + clipBASE + vec3( 10,10,10 );",
			"	if( any(lessThan( clipmax,mdpos )) || any(lessThan( mdpos,clipmin )) ){",
			"		discard;",
			"	}else if( any(lessThan( linemax,mdpos )) || any(lessThan( mdpos,linemin )) ){",
			"		gl_FragColor = vec4( outgoingLight, 1.0 ) * vec4(1.0,0.3,0.3,1.0);",
			"	}else{",
			"		gl_FragColor = vec4( outgoingLight, diffuseColor.a );",
			"	}",
			"}else{",
			"	gl_FragColor = vec4( outgoingLight, diffuseColor.a );",
			"}",
			"}"
		].join( "\\n" )
	  });
		if(mat[i][2] !="" ){
			var texture  = new THREE.ImageUtils.loadTexture(tex[i]);
			texture.magFilter = THREE.NearestFilter;
			texture.minFilter = THREE.NearestFilter;
			texture.wrapS = THREE.RepeatWrapping;
			texture.wrapT = THREE.RepeatWrapping;
			//texture.repeat.set( mat[i][4] ,mat[i][5]);
			materials[i].uniforms.map.value = texture;
			if( mat[i][2] == "png" || mat[i][2] =="gif" ){
				materials[i].uniforms.alphatest.value = 0.5;
			}
		}
		if(mat[i][1] < 1.0){
			materials[i].transparent = true;
			materials[i].blending = THREE.NormalBlending;
		}
        materials[i].side = THREE.DoubleSide;
		materials[i].lights = true;
    }
	linemat = new THREE.ShaderMaterial( {
		vertexShader: "varying vec3 mdpos;void main() {mdpos = vec3(position);gl_Position = projectionMatrix * modelViewMatrix * vec4(position, 1.0);}",
		fragmentShader: [
			"uniform float clipmaxX;", "uniform float clipminX;", "uniform float clipmaxY;", "uniform float clipminY;", "uniform float clipmaxZ;", "uniform float clipminZ;","uniform int use_clipping;",
			"uniform vec3 diffuse;",
			"varying vec3 mdpos;",
			codeclips,
			"void main() {",
			"if( use_clipping == 1 ){",
			"	vec3 clipmax = clipDIST * vec3( clipmaxX , clipmaxY , clipmaxZ ) * 0.01 + clipBASE;",
			"	vec3 clipmin = clipDIST * vec3( clipminX , clipminY , clipminZ ) * 0.01 + clipBASE;",
			"	vec3 linemax = clipDIST * vec3( clipmaxX , clipmaxY , clipmaxZ ) * 0.01 + clipBASE - vec3( 10,10,10 );",
			"	vec3 linemin = clipDIST * vec3( clipminX , clipminY , clipminZ ) * 0.01 + clipBASE + vec3( 10,10,10 );",
			"	if( any(lessThan( clipmax,mdpos )) || any(lessThan( mdpos,clipmin )) ){",
			"		discard;",
			"	}else if( any(lessThan( linemax,mdpos )) || any(lessThan( mdpos,linemin )) ){",
			"		gl_FragColor = vec4( diffuse, 1.0 ) * vec4(1.0,0.3,0.3,1.0);",
			"	}else{",
			"		gl_FragColor = vec4( diffuse, 1.0 );",
			"	}",
			"}else{",
			"	gl_FragColor = vec4( diffuse, 1.0 );",
			"}",
			"}"
		].join( "\\n" ),
		uniforms: {
			clipmaxX: { type: 'f', value: clipMAX },
			clipminX: { type: 'f', value: clipMIN },
			clipmaxY: { type: 'f', value: clipMAX },
			clipminY: { type: 'f', value: clipMIN },
			clipmaxZ: { type: 'f', value: clipMAX },
			clipminZ: { type: 'f', value: clipMIN },
			opacity: { type: 'f', value: 1.0 },
			use_clipping: { type: 'i', value: 1 },
			diffuse: { type: 'c', value: new THREE.Color( 0x000000 ) },
			emissive : { type: "c", value: new THREE.Color( 0x000000 ) }
		},
			linewidth:2
	} );
	materials.push( linemat);
	
	for(var k = 0;k < ngeom	; k++){
	for(var l = 0;l < inslist[k].nins;l++){
	var dfmatid = inslist[k].props[l].dfmat;
	var uscale = mat[dfmatid][4];
	var vscale = mat[dfmatid][5];
	var matrix = new THREE.Matrix4();
	var mtx = inslist[k].props[l].matrix;
	matrix.set(
	mtx[0]/mtx[15],mtx[4]/mtx[15],mtx[8]/mtx[15],mtx[12]/mtx[15],
	mtx[1]/mtx[15],mtx[5]/mtx[15],mtx[9]/mtx[15],mtx[13]/mtx[15],
	mtx[2]/mtx[15],mtx[6]/mtx[15],mtx[10]/mtx[15],mtx[14]/mtx[15],
	mtx[3]/mtx[15],mtx[7]/mtx[15],mtx[11]/mtx[15],1.0
	);
    var geom, vt,vt2, fc, mface,fst,vst;
    geom = new THREE.Geometry();
    for(var j=0; j < geomlist[k].nv; j++){
	  vst = geomlist[k].v[j].split(",");//
      vt = new THREE.Vector3(parseInt(vst[0],36)/Math.pow(10,prec),parseInt(vst[1],36)/Math.pow(10,prec),parseInt(vst[2],36)/Math.pow(10,prec));
      geom.vertices.push(vt);
    }
    for(var j=0; j < geomlist[k].nf; j++){
		fst = geomlist[k].f[j].split(",")
		if( use_texture == true ){
			var uvst = [];
			for(var m=0;m < 3;m++){
				uvst[m] = geomlist[k].uv[j][m].split(",");
			}
		}
		var mati = geomlist[k].mti[j];
		if( mati == 0 ){ //mati = dfmatid; }
			fc = new THREE.Face3( parseInt(fst[0], 36), parseInt(fst[1], 36), parseInt(fst[2], 36), null, null, dfmatid );
			geom.faces.push(fc);
			if( use_texture == true ){
				geom.faceVertexUvs[0].push( [
				  new THREE.Vector2(parseInt(uvst[0][0], 36)/Math.pow(10,prec) * uscale, parseInt(uvst[0][1], 36)/Math.pow(10,prec) * vscale),
				  new THREE.Vector2(parseInt(uvst[1][0], 36)/Math.pow(10,prec) * uscale, parseInt(uvst[1][1], 36)/Math.pow(10,prec) * vscale),
				  new THREE.Vector2(parseInt(uvst[2][0], 36)/Math.pow(10,prec) * uscale, parseInt(uvst[2][1], 36)/Math.pow(10,prec) * vscale)]
				);
			}
		}else{
			fc = new THREE.Face3( parseInt(fst[0], 36), parseInt(fst[1], 36), parseInt(fst[2], 36), null, null, mati );
			geom.faces.push(fc);
			if( use_texture == true ){
				geom.faceVertexUvs[0].push( [
				  new THREE.Vector2(parseInt(uvst[0][0], 36)/Math.pow(10,prec), parseInt(uvst[0][1], 36)/Math.pow(10,prec)),
				  new THREE.Vector2(parseInt(uvst[1][0], 36)/Math.pow(10,prec), parseInt(uvst[1][1], 36)/Math.pow(10,prec)),
				  new THREE.Vector2(parseInt(uvst[2][0], 36)/Math.pow(10,prec), parseInt(uvst[2][1], 36)/Math.pow(10,prec))]
				);
			}
		}
    }
	geom.applyMatrix(matrix);
	geom.applyMatrix(mrot);
    geom.computeFaceNormals();
    mface = new THREE.Mesh(geom, new THREE.MeshFaceMaterial(materials));
	mface.castShadow = true;
	mface.receiveShadow = true;
    scene.add( mface );
	var edgeom = new THREE.Geometry();
    for(var j=0; j < geomlist[k].ne; j++){
		if(geomlist[k].ed[j]){
		edst = geomlist[k].ed[j].split(",")
		vst = geomlist[k].v[parseInt(edst[0], 36)].split(",");//
		edgeom.vertices.push( new THREE.Vector3(parseInt(vst[0],36)/Math.pow(10,prec),parseInt(vst[1],36)/Math.pow(10,prec),parseInt(vst[2],36)/Math.pow(10,prec)) );
		vst = geomlist[k].v[parseInt(edst[1], 36)].split(",");//
		edgeom.vertices.push( new THREE.Vector3(parseInt(vst[0],36)/Math.pow(10,prec),parseInt(vst[1],36)/Math.pow(10,prec),parseInt(vst[2],36)/Math.pow(10,prec)) );
		}
    }
	edgeom.applyMatrix(matrix);
	edgeom.applyMatrix(mrot);
	//edgeom.translate(mtx[12],-mtx[13],-mtx[14]);
	var lines = new THREE.LineSegments( edgeom,linemat );
	scene.add( lines );
}
}
	texture_show( true);
	add_gui();
    // 画面リサイズ時のイベント
    window.addEventListener( 'resize', onWindowResize, false );
}
function add_gui(){
var SUPPORTS_LOCAL_STORAGE = (function() { try { return 'localStorage' in window && window['localStorage']; } catch (e) { return false; } })();
if( SUPPORTS_LOCAL_STORAGE ){
	var gui = new dat.GUI();
	parameters = {
		场景选择: function(){document.getElementById('modal').style.display="block";},
		lookaround:false,
		textureon:true,
		useclip:true,
		useshadow:true,
		ambicolor: "#bbbbbb",
		suncolor: "#cccccc",
		subcolor: "#cccccc",
		headcolor: "#cccccc",
		flyspeed:50,
		gclipxmax:1.0,
		gclipxmin:1.0,
		gclipymax:1.0,
		gclipymin:1.0,
		gclipzmax:1.0,
		gclipzmin:1.0
	};
	var skpage = gui.add( parameters, '场景选择');
	SCENE_SELECT
	document.getElementById('sceneselect').innerHTML = scenetable;
	var sklookaround = gui.add( parameters, 'lookaround' ).name('环绕观察').listen();
	sklookaround.onChange(function(value){   controls.lookaround = value;  	});
	var skflyspeed = gui.add( parameters, 'flyspeed' , 1 , 100).name('飞行速度').listen();
	skflyspeed.onChange(function(value){   controls.flyspeed = value;  	});
	var sktextureon = gui.add( parameters, 'textureon' ).name('纹理 开/关').listen();
	sktextureon.onChange(function(value){   texture_show( value);  	});
	var skshadowon = gui.add( parameters, 'useshadow' ).name('阴影 开/关').listen();
	skshadowon.onChange(function(value){
		renderer.shadowMapEnabled = value;
		for(var i=0; i < materials.length; i++){materials[i].needsUpdate=true;}
	});
	var f_clips = gui.addFolder('剖切平面');
	var skuseclip = f_clips.add( parameters, 'useclip' ).name('启用剖切').listen();
	skuseclip.onChange(function(value){
		for(var i=0; i < materials.length; i++){
			materials[i].uniforms.use_clipping.value = value;
		}
	});
	var skclipxmax = f_clips.add( parameters, 'gclipxmax' , clipMIN , clipMAX).name('X 轴末端裁切').listen();
	skclipxmax.onChange(function(value){
		for(var i=0; i < materials.length; i++){
			materials[i].uniforms.clipmaxX.value = value;
		}
	});
	var skclipxmin = f_clips.add( parameters, 'gclipxmin' , clipMIN , clipMAX).name('X 轴首端裁切').listen();
	skclipxmin.onChange(function(value){
		for(var i=0; i < materials.length; i++){
			materials[i].uniforms.clipminX.value = value;
		}
	});
	
	var skclipzmax = f_clips.add( parameters, 'gclipzmax' , clipMIN , clipMAX).name('Y 轴末端裁切').listen();
	skclipzmax.onChange(function(value){
		for(var i=0; i < materials.length; i++){
			materials[i].uniforms.clipmaxZ.value = value;
		}
	});
	var skclipzmin = f_clips.add( parameters, 'gclipzmin' , clipMIN , clipMAX).name('Y 轴首端裁切').listen();
	skclipzmin.onChange(function(value){
		for(var i=0; i < materials.length; i++){
			materials[i].uniforms.clipminZ.value = value;
		}
	});

	var skclipymax = f_clips.add( parameters, 'gclipymax' , clipMIN , clipMAX).name('Z 轴末端裁切').listen();
	skclipymax.onChange(function(value){
		for(var i=0; i < materials.length; i++){
			materials[i].uniforms.clipmaxY.value = value;
		}
	});
	var skclipymin = f_clips.add( parameters, 'gclipymin' , clipMIN , clipMAX).name('Z 轴首端裁切').listen();
	skclipymin.onChange(function(value){
		for(var i=0; i < materials.length; i++){
			materials[i].uniforms.clipminY.value = value;
		}
	});
	var f_lights = gui.addFolder('光照设置');
	var sklight1 = f_lights.addColor( parameters, 'ambicolor' ).name('环境光').listen();
	sklight1.onChange(function(value){   light1.color = new THREE.Color(value);  	});
	var sklight2 = f_lights.addColor( parameters, 'suncolor' ).name('太阳光').listen();
	sklight2.onChange(function(value){   light2.color = new THREE.Color(value);  	});
	var sklight3 = f_lights.addColor( parameters, 'subcolor' ).name('辅助光').listen();
	sklight3.onChange(function(value){   light3.color = new THREE.Color(value);  	});
	var sklight4 = f_lights.addColor( parameters, 'headcolor' ).name('前照灯').listen();
	sklight4.onChange(function(value){   headlight.color = new THREE.Color(value);  	});
	gui.open();
	f_clips.open;
	parameters.gclipxmax = clipMAX;
	parameters.gclipymax = clipMAX;
	parameters.gclipzmax = clipMAX;
	parameters.gclipxmin = clipMIN;
	parameters.gclipymin = clipMIN;
	parameters.gclipzmin = clipMIN;

}
    // 添加主项“操作说明”
    var controls = gui.addFolder('操作说明（按下对应按键并在视图中拖动）');
    // 添加纯文本说明
    controls.add({ text: "[鼠标左键]" }, 'text').name("旋转视图").listen();
    controls.add({ text: "[鼠标滚轮][鼠标中键]" }, 'text').name("缩放视图").listen();
    controls.add({ text: "[Shift+鼠标中键][右键]" }, 'text').name("平移视图").listen();
    // 开启折叠效果
    // controls.open();
}
// ウィンドウリサイズ時の動作
function onWindowResize() {
  var width = container.offsetWidth;
  var height = container.offsetHeight;
  camera.aspect = width / height;
  camera.updateProjectionMatrix();
  renderer.setSize(width, height);
  //effect.setSize(width, height);
}
function texture_show(chk){
    for(var i=0; i < mat.length; i++){
      if (mat[i][2] != ""){
        // texture付material：画像をLoad
		if(chk){
			materials[i].uniforms.usemap.value = 1;
			//materials[i].overdraw = true;
			materials[i].needsUpdate = true;
		}else{
			materials[i].uniforms.usemap.value = 0;
			//materials[i].overdraw = true;
			materials[i].needsUpdate = true;
		}
      }
    }
}
  // 
  function render() {
    requestAnimationFrame(render);
    controls.update();
    renderer.render(scene, camera);
  }

</script>

</body></html>
)#%Q記法 END

end
=begin
	var skpage = gui.add( parameters, 'scene', [ SCENE_LIST ] ).name('scene').listen();
	skpage.onChange(function(value){
		switch( value ){
			SCENE_SELECT
		}
		controls.object.position.set(cpos[0],cpos[1],cpos[2]);
		controls.target = new THREE.Vector3(ctgt[0],ctgt[1],ctgt[2] ); 
		document.activeElement.blur();
		onWindowResize;
	});
=end
end
# add a menu 
if (not file_loaded?("t2h_export_webgl.rb"))
  UI.menu("Plugins").add_item("T2H - 输出模型为网页") { Webgl_export.new() }
end
file_loaded("t2h_export_webgl.rb")
#----------------------------
end
end
